<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>URI Library</h1>

		<p>The URI library provides an interface for retrieving information from URI strings.  If you use URI
		routing you can also retrieve information about the rerouted segments.  <i>Note</i>: the config library is
		automatically loaded by CarbonPHP so there is no need for you to load it.</p>
	</div>

	<div class="content">
		<h1>$this->uri->segment(index)</h1>

		<p>This allows you to retrieve a specific segment.  Where <b>index</b> is the segment number you wish to
		retrieve.  Segments are numbered from left to right.</p>

		<div class="example">
			www.your-domain.com/index.php/blog/archives/2007/09/
		</div>

		<p>The segment numbers would be the following.</p>

		<ol>
			<li>blog</li>
			<li>archives</li>
			<li>2007</li>
			<li>09</li>
		</ol>

		<p>By default the function will return <b>false</b> if a segment does not exist.  There is an optional second
		parameter that allows you to set your own return value if a segment does not exist.</p>

		<div class="example">
			$post_id = $this->uri->segment(3, 0);
		</div>
	</div>

	<div class="content">
		<h1>$this->uri->rsegment(index)</h1>

		<p>This method is identical to the above one, except it retrieves the segment from your rerouted URI if you
		are using CarbonPHP's URI routing feature.</p>
	</div>

	<div class="content">
		<h1>$this->uri->slash_segment(index)</h1>

		<p>This method is almost identical to <b>$this->uri->segment()</b>, except it adds a trailing slash and/or
		leading slash based on the second parameter.</p>

		<div class="example">
			$this->uri->slash_segment(<b>3</b>);<br />
			$this->uri->slash_segment(<b>3</b>, 'leading');<br />
			$this->uri->slash_segment(<b>3</b>, 'both');
		</div>

		<p>The above example would return the following.</p>

		<ul>
			<li>segment/</li>
			<li>/segment</li>
			<li>/segment/</li>
		</ul>
	</div>

	<div class="content">
		<h1>$this->uri->slash_rsegment(index)</h1>

		<p>This method is identical to the above method except that it lets you add slashes to a segment from your
		rerouted URI if you're using CarbonPHP's URI routing feature.</p>
	</div>

	<div class="content">
		<h1>$this->uri->get_uri_to_assoc(index)</h1>

		<p>This method lets you turn URI segments into an associative array of keys and values.</p>

		<div class="example">
			index.php/user/search/name/john/country/england/gender/male
		</div>

		<p>Using this method on this URL would turn it into the following array with the following prototype.</p>

		<div class="example">
			[array]<br />
			(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'name' => 'john',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'country' => 'england',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'gender' => 'male'<br />
			)
		</div>

		<p>The first parameter of the method lets you set an offset.  By default the offset is set to 3 since your
		URI will contain a controller and method name in the first and second segments.</p>

		<p>The second parameter lets you set default key names, so that the array returned by the method will always
		contain expected indexes, even if they are missing from the URI.</p>

		<p>If the URI does not contain a value in your default an array index will be set to that name with a value of
		<b>false</b>.  Also if a value is not found for a given array key the value will be set to <b>false</b>.</p>
	</div>

	<div class="content">
		<h1>$this->uri->get_ruri_to_assoc(index)</h1>

		<p>This method is identical to the above one except that it creates an associative array using the rerouted
		URI if you're using the CarbonPHP URI routing feature.</p>
	</div>

	<div class="content">
		<h1>$this->uri->assoc_to_uri($array)</h1>

		<p>This method takes an associative array and generates a URI string from it.</p>

		<div class="example">
			$array = array('product' => 'shirts', 'size' => 'medium', 'colour' => 'blue');<br />
			<br />
			$string = $this->uri->assoc_to_uri($array);<br />
			<br />
			// Will generate: product/shirts/size/medium/colour/blue
		</div>
	</div>

	<div class="content">
		<h1>$this->uri->get_uri_string()</h1>

		<p>This method returns a string with the complete URI.</p>

		<div class="example">
			www.your-domain.com/index.php/blog/post/4
		</div>

		<p>This URI would return the following string.</p>

		<div class="example">
			blog/post/4
		</div>
	</div>

	<div class="content">
		<h1>$this->uri->get_ruri_string()</h1>

		<p>This method is identical to the above one except that it returns the rerouted URI if you're using the
		URI rerouting feature of CarbonPHP.</p>
	</div>

	<div class="content">
		<h1>$this->uri->total_segments()</h1>
		
		<p>Returns the total number of URI segments.</p>
	</div>

	<div class="content">
		<h1>$this->uri->total_rsegments()</h1>
		
		<p>Returns the total number of URI segments in a re-routed URI.</p>
	</div>

	<div class="content">
		<h1>$this->uri->get_segment_array()</h1>
		
		<p>Returns an array of URI segments.</p>
	</div>

		<div class="content">
		<h1>$this->uri->get_rsegment_array()</h1>
		
		<p>Returns an array of re-routed URI segments.</p>
	</div>
</body>

</html>
